#### 일반위젯(Widget-Taxo)

- 웹페이지에는 페이지를 렌더링하는 개별적인 섹터로 나뉘게 되는데, 예를 들면 홈페이지 메뉴와 그 하단의 이미지 슬라이드 그리고 맨 하단의 Footer 등으로 나뉘어지는 섹터들을 "위젯"으로 부른다.
- 위젯은 홈페이지나 푸터와 같은 부분은 여러 페이지에서 공유되는 위젯이며 이렇게 위젯으로 나뉘어 놓으면 수많은 웹페이지들을 렌더링할때 선별적으로 가져와서 렌더링할 수 있으므로 빠른 시간내에 웹페이지를 체계적으로 구성할 수 있게 된다. 
- 일반 위젯이란 메인 메뉴와 같은 "기능 위젯"가 달리 (1)이미지 슬라이드 (2)이미지 카루젤 (3)일반 Side Bar (4) Footer 등 단순한 이미지와 텍스트를 보여줄 수 있도록 직접 사용자가 웹에디터를 이용하여 수정할 수 있도록 구성되는 위젯의 한 종류이다.

#### 서브위젯(Widget-Taxo)

- 서브 위젯은 하나의 위젯내에 부속되는 위젯인데, 예를들면 메인 슬라이드를 랜더링할때 위해서 모션이 일어나는 타이틀, 서브타이들의 글자나 이미지, 아이콘들로서 사용될 수 있다. 

#### 위젯 코드
- 각 위젯의 용도와 주 사용 위치를 규정하여 사용자가 수정할 때 쉽게 찾을 수 있도록 정한 코드로써
- (1) cm, ma, mb, mc 의 prefix가 순서적으로  붙어서 시스템에서 지정된 코드와 
- (2) mc 이후의 prefix로 입력하는 사용자 지정 코드 2개의 그룹으로 나누어 
만들어 나갈 수 있다.

#### 구분 코드
- 위젯은 언어와 브라우저의 크기에 언어적인 표현과 기기별 이미지 사이즈가 달리 표현될 수 있으며 
- (1) 언어 구분은 Laravel의 .env 화일의 "LOCALE_SEQUENCE"에 표현된 순서대로 추가 가능하다. 
- ~ 이 경우, LOCALE_SEQUENCE 에 맨 먼저 나오는 언어가 Default 언어가 된다.
- (2) 기기는 현재로써는 desktop(PC), mobile(스마트폰), tablet(태블릿PC)만 지원이 가능하여, 그 구분은 접속되는 기기가 아니라 접속되는 브라우저의 너비에 의해 결정된다.
- 이 경우, .env 화일의 DEVICE_SCALE 에서 범위로 정해준 px 범위에 의해 결정되며 사용 상황에 따라 웹브라우저의 너비를 변경할 수 있다.

#### 위젯명
- 위젯명은 사용자가 기억하기 쉬운 명칭으로 정하여 활용할 수 있도록 한다.


#### 위젯번호
- 위젯번호는 시스템 내부에서 년월일-일련번호로 자동으로 할당되어 구분/언어/기기 별 위젯에 대한 고유번호로 지정된다.

#### 주의 사항
- (1) 구분/언어/기기 가 합쳐진 내용인 유일한 정보가 되므로 구분/언어/기기 통합된 내용을 반복적으로 추가할 수 없다.
