#### 품목 구분 코드의 정의

- (1) 품목 구분 코드는 코드 그 자체로 품목 구분의 위계를 구성할 수 있다.
- (2) 2자리씩 3개의 레벨로 구성하며 반드시 숫자 로 구성한다. 
- (3) 예) 10 20 40 => 102040 에서 10은 첫번째 레벨, 20은 두변째 레벨, 40은 3번째 레벨의 위치를 구성한다.
- (4) 만약 102000 처럼 두번째 레벨에서 끝날 경우 해당 2단계 구분이 "말단 구분" 이 된다. 
- (5) 특수하게 제작되는 경우가 아니라면 품목 구분은 3단계만 지원이 된다. 일반적으로 3단계가 넘으면 이후에는 분류가 잘 안되는 경우가 많다.

#### 말단 구분
- 품목 구분의 단계에서 제일 마지막 단계의 구분이며 실제적으로 품목이 연결되는 구분이다. 
- 예) 뷰티상품 > 향수 > 여성향수 의 경우 품목은 여성향수 에만 연결될 수 있으며 상위 구분은 하위 구분의 내용을 포함하여 상품 게시 된다.

#### DUID (Dabory Unique Identification) 
- DUID는 서로 다른 웹사이트에서 데이터 레코드를 공유하게 될 때 원래의 소유권이 어디에 있었던 가를 검증하는 지표가 되는 Id로 활용되며 레코드가 만들어질 때 자동으로 생성된다.
- 독립형 웹사이트에서는 크게 활용되지 않으며 DUID가 공란이면 업로드시 그 값이 자동으로 할당되고 이미 생성되어 존재하면 동일한 값으로 들어가게 됩니다.  해당 업로드는 기존의 값을 완전히 없에고 업로드하는 경우이므로 만약 엑셀입력란이 있다면 공란으로 만들어 놓으면 된다.



#### 주의 사항
- (1) 품목 구분의 Id 는 실제로 품목과 연관(Join)이 걸리는 포인트이므로 품목 구분의 초기 설정단계에서는 임의로 수정해도 되지만 일단 품목이 연결되면 수정해서는 안된다. 그렇지 않은 경우 품목이 품목 구분을 잃어버로고 고아 레코드가 되므로 품목이 없어진 것처럼 보이기 때문이다. 또는 Id는 유일한 키값이므로 중복해서 업로드 할 수 없다.(중요)
- (2) 품목 구분과 메인메뉴와 연동할 경우 반드시 품목 구분코드와 메인 메뉴 코드를 일치시킨다. 
- (3) 메인메뉴 코드의 게시판 메뉴나 회원 관리 메뉴는 품목 구분 코드가 점유되지 않는 뒷 번호에 위치하도록 한다. 일반적으로 품목구분 메뉴를  890000 번대 이전로 배치하고 일반 메뉴를 900000 번대 이후로 배치하여 충돌하지 않도록 하면 무난한 설정이 된다.
- (4) 기존에 있던 품목구분id는 변경하지말고 추가되는 구분부터 id를 기존의 있던 맨 마지막 ID의 값에서 1씩 증가시키면서 추가한 후 엑셀에 저장하면 된다. ("엑셀의 연속데이터 채우기" 기능 활용 가능)
