#### 메인 메뉴 코드의 정의

- (1) 메인메뉴 코드는 코드 그 자체로 품목 구분의 위계를 구성할 수 있다.
- (2) 2자리씩 3개의 레벨로 구성하며 반드시 숫자 로 구성한다. 
- (3) 예) 10 20 40 => 102040 에서 10은 첫번째 레벨, 20은 두변째 레벨, 40은 3번째 레벨의 위치를 구성한다.
- (4) 만약 102000 처럼 두번째 레벨에서 끝날 경우 해당 구분이 "말단 구분" 이 된다. 
- (5) 특수하게 제작되는 경우가 아니라면 메인 메뉴는 3단계만 지원이 된다. 일반적으로 3단계가 넘으면 이후에는 분류가 잘 안되는 경우가 많다.

#### 말단 구분
- 메인 메뉴의 단계에서 제일 마지막 단계의 구분이며 실제적으로 게시되는 페이지가 연결되는 구분이다. 
- 예) 일단적으로 회사소개 > 연혁 > 기간별 연혁 처럼  "기간별 연혁" 에만 게시되는 페이지가 연결되는 경우가 대부분이므로 참고한다. 특수제작할 경우 중간 메뉴에 페이지가 달릴 수도 있다.

#### 언어/기기 구분
- 언어별 기기별로 다른 메뉴를 구성할 수 있다.

#### 품목 구분과 메인메뉴의 다른점
- 메인메뉴의 "primary" 메뉴종류에는 품목 구분 이외의 게시판, 회원 관리, 회사 소개 등의 메뉴을 추가해서 표현할 수 있다.
- 메인메뉴의 "top", "sidebar", "footer" 등의 다양한 메뉴를 추가 정의해서 표현할 수 있다. 따라서 메뉴코드가 같아도 메뉴종류만 다르면 중복해서 사용할 수 있다.
- 메인 메뉴는 자동으로 하위 품목 구분의 모든 품목을 보여줄 수 있도록 하는 슬러그(C9:페이지 URI)가 업로드시 자동으로 만들어진다.
- 따라서 C9란은 엑셀에서 변경 입력하지 않아도 자동 생성 된다. (다운로드는 단순 확인용)
- 메인메뉴는 품목과 직접 연결되지 않으므로 엑셀의 ID 컬럼을 처음 라인에서 끝까지 드래그 한 후 "연속 데이터 채우기"로 입력하면 된다.

#### 주의 사항
- (1) 메인메뉴의 Id 는 다시 수정/추가 업로드하는 경우라도 변경해서 업로드 가능하다. 단 Id는 유일한 키값이므로 중복되는 값을 업로드 할 수 없으므로 "실테이블에 적용"시 에러가 발생한다.(중요)
- (2) primary, top 등 의 Sort만 다르면 동일한 메뉴코드라도 중복이 가능하다.
- (3) primary, top 어느하나의 메뉴라도 삭제하거나 변경하여 업로드하면 즉각 반영된다. 실수로 top 메뉴를 삭제하지 않도록 유의한다.
- (4) 메인메뉴는 캐싱 항목이므로 "캐시 삭제"를 클릭해야 실제 적용이 가능하다.
